require "draw"
require "load"

function love.load()
    love.graphics.setBackgroundColor( 0, 0, 0 )
    --love.graphics.setDefaultImageFilter("nearest", "nearest")

    winW=love.graphics.getWidth()
    winH=love.graphics.getHeight()
    size = 80
    sc = 4

    map = loadMap(1)
    bg = love.graphics.newImage("/graphics/background.png")

    local lframe = 1
    local bggraphics = {}
    while love.filesystem.exists("/graphics/ps".. lframe ..".png") do
        table.insert(bggraphics,love.graphics.newImage("/graphics/ps".. lframe ..".png"))
        lframe = lframe + 1
    end


    bgscrolling = {{img = bggraphics[3],speed = 0.03,y=50, x= 500},{img = bggraphics[9],speed = 0.1, x=1800,y=180},{img = bggraphics[8],speed = 0.2, x=3600,y=180},{img = bggraphics[4],speed = 0.1,y=200, x= 3000},{img = bggraphics[5],speed = 0.2,y=200, x= 6000},{img = bggraphics[2],speed = 0.1, x=0,y=180},{img = bggraphics[1], speed = 0.3, x = 150, y =180},{img = bggraphics[6],speed = 0.3,y=480, x= 5400},{img = bggraphics[7],speed = 0.1,y=495, x= 15000}}

    black = love.graphics.newImage("/graphics/corners.png")
    cloud = love.graphics.newImage("/graphics/cloud.png")

    dead = love.graphics.newImage("/graphics/bomb/dead.png")

    clock = love.graphics.newImage("/graphics/clock.png")
    red = love.graphics.newImage("/graphics/dclock.png")

    glare = love.graphics.newImage("/graphics/glare.png")
    imggrass = love.graphics.newImage("/graphics/grass.png")
    decoder = love.sound.newDecoder("/musik.mp3")
    music = love.audio.newSource(decoder, "stream")

    blip = love.sound.newDecoder("/blip.wav")
    effect = love.audio.newSource(blip, "static")
    bad = love.sound.newDecoder("/bad.wav")
    hurt = love.audio.newSource(bad, "static")

    music:setLooping(true)
    love.audio.play(music)

    font = love.graphics.newFont(20)
    love.graphics.setFont(font)
    
	
    clocks = {}
    for x = 300, 1500, 600 do
        addClock(x, "white")
    end

    imageTiles = love.graphics.newImage("/graphics/tiles.png")
    wholeW = imageTiles:getWidth()
    wholeH = imageTiles:getHeight()

    tileQuads = constructQuadData(imageTiles,size)

    player = {x = 300, y = 300, time=10, animation= {}, frame = 1, falling = true,k = 0, moving = false, dir = 1, speed = 0, maxspeed = 300, alive = true}

    --lets load the animation
    local lframe = 1
    while love.filesystem.exists("/graphics/bomb/robot-".. lframe ..".png") do
		table.insert(player.animation, love.graphics.newImage("/graphics/bomb/robot-".. lframe ..".png"))
		lframe = lframe + 1
	end

    --environment displacement
    dispx = 0

    clouds = {}


    local t  = math.random(100,800)
    while t < 10000 do
        table.insert(clouds, newCloud(t))
        t = t + math.random(300,1000)

    end

    
    flicker = 100

    goal = 1200

    goalFloor = 80

    grass = {}
    disableGrass = false

    fade = 0

    score = 0 
    
end

function addGrass()
    table.insert(grass, {x= dispx + 900, y = 547})
end

function touchGrass()
    for i=1, #grass do        
        if player.x+40 > grass[i].x-dispx+20 and player.x+40 < grass[i].x-dispx+140 then
            if player.y > 540 then
                player.maxspeed = 50
            end
        end

        if grass[i].x-dispx < -200 then
            table.remove(grass, i)
            return
        end
    end
end

function addClock(x, color)
    local clock = {}
    clock.x = x
    clock.y = math.random(300,540)
    clock.color = color
    table.insert(clocks, clock)
end


function love.update(dt)
    if player.alive then
    score = score + 1*dt
    getFlicker()

    player.maxspeed = 300
    touchGrass()
    
    player.moving = false
    if love.keyboard.isDown("right") then
        player.moving = true
        if player.dir == -1 then player.speed = 0 end
        player.dir = 1
        if player.x < 480 then
            player.x = player.x + player.speed*dt
        else
            player.x = 480
            dispx = dispx + dt*player.speed
        end
        player.speed = player.speed + 100*dt
        if player.speed >= player.maxspeed then player.speed = player.maxspeed end

        if dispx+player.x > goal then
            goal = player.x+ dispx + 1000
            addClock(goal + 1000, "white")
            
        end
        if dispx > goalFloor then
            goalFloor = goalFloor + 80
            table.insert(map,math.random(1,2))
            if math.random(1,10) == 1 and disableGrass == false then
                addGrass()
                disableGrass = true
            else
                if math.random(1,3) == 1 then
                    disableGrass = false
                end
            end
            
            
            local c = 10 + mf((1000+dispx)/1000)
            
            if c >= 70 then c = 70 end 
            if math.random(1,300) <= c then
                addClock(dispx+900,"red")
            end
        end
    end
    
    

    if love.keyboard.isDown("left") then
        if player.dir == 1 then player.speed = 0 end
        player.moving = true
        player.dir = -1
        if player.x > 320 or dispx <= 1 then
            if player.x >= 0 then
                player.x = player.x - player.speed*dt
            end
        else
            player.x = 320
            dispx = dispx - player.speed*dt
        end

        player.speed = player.speed + 100*dt
        if player.speed >= player.maxspeed then player.speed = player.maxspeed end
    end

    if player.moving == false then player.speed = 0 end

    if player.falling then
        player.y = player.y + 100*dt*player.k
        player.k = player.k + 30*dt
    end

    if player.moving then
        player.frame = player.frame + (1+3*(player.speed/100))*dt
        if player.frame >= 9 then player.frame = player.frame - 8 end
    end


    player.time = player.time-1*dt
    if player.time <= 0 then
        player.alive = false
        --love.event.quit()
    end
    collY()

    touchClock()
    else
        fade = fade + 400*dt
        if fade >= 255 then fade = 255 end
        love.audio.stop(music)

    end
end

function collY()
    local testX = mf((player.x+dispx)/size)+1
    local testY = mf(player.y/size)+1
    if testY > 0 and testY <= 9 then
    if testX > 0 then
        if map[testX] > 0 and testY == 8 then
            player.falling = false
            player.k=0
            player.y = (testY-1)*80-2
    
        end
    end
    end
end

function touchClock()
    for i=1, #clocks do

        if clocks[i].x-dispx+10 > player.x+8 and clocks[i].x-dispx+10 < player.x+80-8 then
            if clocks[i].y+10 > player.y+12-100 and clocks[i].y+12 < player.y-100+120 then
                if clocks[i].color == "white" then  
                    player.time = 10
                    love.audio.stop(effect)
                    love.audio.play(effect)
                    flicker = 255
                else
                    player.time = player.time - 2
                    love.audio.stop(hurt)
                    love.audio.play(hurt)
                    flicker = 0
                end

                if player.time >= 10 then player.time = 10 end

                table.remove(clocks,i)
            
                return
                --(player.x+8,player.y+12,72,102)
            end
        end

    end
end


function newCloud(a)
    local c = {x=a,y= math.random(50,300),alpha = math.random(255,255),scale = math.random(80,120)/100, speed = math.random(50,200)/1000}
    return c
end

function mf(t) 
    t = math.floor(t)
    return t
end

function love.draw() 
    love.graphics.setColor(255,255,255,200)
    love.graphics.setBlendMode("alpha")
    love.graphics.draw(bg,0,0,0)

    drawClouds()

    drawScrolling()

    drawMap()
    drawGrass()

    drawClocks()
    
    if player.alive then
        if player.dir == 1 then love.graphics.draw(player.animation[mf(player.frame)],mf(player.x),mf(player.y)-100,0,player.dir,1) end
        if player.dir == -1 then love.graphics.draw(player.animation[mf(player.frame)],mf(player.x)+80,mf(player.y)-100,0,player.dir,1) end
    else
        love.graphics.draw(dead,mf(player.x),mf(player.y)-100)
    end
    drawTimer()

    love.graphics.setBlendMode("multiplicative")
    love.graphics.setColor(255,255,255,255)

    love.graphics.draw(black,player.x-100*sc*2+150,player.y-100*sc*2+150,0,sc*2,sc*2)
    love.graphics.setColor(0,0,0,fade)
    if fade > 0 then
        love.graphics.rectangle("fill",0,0,800,640)
    end
    love.graphics.setColor(255,255,255,flicker)
    love.graphics.setBlendMode("additive")
    if player.alive then
    love.graphics.draw(glare,player.x-10,player.y-105)
    else
        if fade >= 235 then

            love.graphics.setBlendMode("alpha")
            love.graphics.setColor(255,255,255,255)
            love.graphics.print("Your 10 second battery survived for "..tostring(mf(score).." seconds! Good job!"),100,300)
            love.graphics.setBlendMode("additive")
        end
    end

    
end

function getFlicker()
    local blah = math.random(-5,5)
    if blah == 0 then
        blah = math.random(-60,60)
    end
    flicker = flicker + blah
    if flicker >= 200 then flicker = 200 end
    if flicker <= 0 then flicker = 0 end

end


function love.keypressed(key)
    if key == "up" and not player.falling then
        player.k = -12
        player.falling = true
    end
end

function love.mousepressed(x, y, button)

end